package eu.ocopomo.chat;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class ChatUser {

    private String jid;
    private Set<String> roster;
    private Set<String> sessions;
    private Set<String> rooms;
    private Map<String, String> timestamps;
    private String openedRoomFlag;

    public ChatUser(String jid , Set<String> roster) {
        this.jid = jid;
        this.roster = roster;
        this.rooms = new HashSet<String>();
        this.sessions = new HashSet<String>();
        this.timestamps = new HashMap<String, String>();
        this.openedRoomFlag = "not_opened_room";
    }
    
    public Set<String> getRoster(){
        return roster;
    }
    
    public Set<String> getRooms(){
        return rooms;
    }
    
    public String getOpenedRoomFlag(){
        return openedRoomFlag;
    }
    
    public void setOpenedRoomFlag(String openedRoomFlag){
        this.openedRoomFlag = openedRoomFlag;
    }
    
    public synchronized void addToRoster(String jid){
        this.roster.add(jid);
    }
    
    public synchronized void removeFromRoster(String jid){
        this.roster.remove(jid);
    }
    
    public synchronized void setTimestamp(String roomid, String newts){
        this.timestamps.put(roomid, newts);
    }
    
    public synchronized void removeTimestamp(String roomid){
        this.timestamps.remove(roomid);
    }
    
    public Map<String, String> getTimestamps(){
        return timestamps;
    }
    
    public Set<String> getSessions(){
        return sessions;
    }
    
    public synchronized void addToSessions(String sid){
        this.sessions.add(sid);
    }
    
    public synchronized void removeFromSessions(String sid){
        this.sessions.remove(sid);
    }
    
    public synchronized void addToRooms(String roomId){
        this.rooms.add(roomId);
    }
    
    public synchronized void removeFromRooms(String roomId){
        this.rooms.remove(roomId);
    }
    
    public String getJid(){
        return jid;
    }
    
    public boolean hasSessions(){
        if(sessions.isEmpty()) return false;
        else return true;
    }
    
    public boolean hasInRoster(String jid){
        if(roster.contains(jid)) return true;
        else return false;
    }
}

