package eu.ocopomo.chat;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.UnsupportedEncodingException;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.client.HttpClient;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.FileEntity;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

public class ChatServletTest2 {
    
    private static HttpClient client;
    
    public ChatServletTest2() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
        client = new DefaultHttpClient();
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
        client = null;
    }
    
    @Before
    public void setUp() {
    }
    
    @After
    public void tearDown() {
    }

   
    @Test
    public void testStartingConnection() throws Exception {
        HttpPost post = new HttpPost("http://localhost:8084/chat/ChatServlet");
        
        post.setEntity(new FileEntity(new File("test/eu/ocopomo/chat/connection.json"), "application/json"));
        
        HttpResponse resp = client.execute(post);
        
        printTestInfo(post, resp, "Connection Butka");
    }

    @Test
    public void testCreateChatPlusNewSubject() throws Exception {
        HttpPost post = new HttpPost("http://localhost:8084/chat/ChatServlet");
        
        post.setEntity(new FileEntity(new File("test/eu/ocopomo/chat/nonemptybody2.json"), "application/json"));
        
        HttpResponse resp = client.execute(post);
        
        printTestInfo(post, resp, "Create chat and change subject");
    }
    
    @Test
    public void testStartingConnection2() throws Exception {
        HttpPost post = new HttpPost("http://localhost:8084/chat/ChatServlet");
        
        post.setEntity(new FileEntity(new File("test/eu/ocopomo/chat/connection2.json"), "application/json"));
        
        HttpResponse resp = client.execute(post);
        
        printTestInfo(post, resp, "Connection Bednar");
    }
    
    @Test
    public void testQuery() throws Exception {
        HttpPost post = new HttpPost("http://localhost:8084/chat/ChatServlet");
        
        post.setEntity(new FileEntity(new File("test/eu/ocopomo/chat/query.json"), "application/json"));
        
        HttpResponse resp = client.execute(post);
        
        printTestInfo(post, resp, "Test query Bednar + new message and subject");
    }
    
    @Test
    public void testQuery2() throws Exception {
        HttpPost post = new HttpPost("http://localhost:8084/chat/ChatServlet");
        
        post.setEntity(new FileEntity(new File("test/eu/ocopomo/chat/query2.json"), "application/json"));
        
        HttpResponse resp = client.execute(post);
        
        printTestInfo(post, resp, "Test query Butka");
    }
    
    private void printTestInfo(HttpPost post, HttpResponse resp, String testInfo) throws IOException{
        System.out.println("*************************************");
        System.out.println("TEST - " + testInfo);
        System.out.println("-------Request-Entity----------------");
        System.out.println(streamToString(post.getEntity().getContent()));
        System.out.println("-------Response-Status-line----------");
        System.out.println(resp.getStatusLine()); 
        System.out.println("-------Response-Entity---------------");
        System.out.println(streamToString(resp.getEntity().getContent()));
    }
    
    private String streamToString(InputStream is) throws UnsupportedEncodingException, IOException{
        final char[] buffer = new char[0x10000];
        StringBuilder out = new StringBuilder();
        Reader in = new InputStreamReader(is, "UTF-8");
        int read;
        do {
            read = in.read(buffer, 0, buffer.length);
            if (read>0) out.append(buffer, 0, read);
        } while (read>=0);
        return out.toString();
    }
}
